local name, addon = ...
local modName = "autorepair"
local getPref = addon['MH_GetPref']
local options

local message = {
	["enUS"] = "Autorepair",
	["deDE"] = "Automatisch reparieren",
	['repaircostgb'] = function(r)
		if(GetLocale() == "deDE") then
			return "Reparaturkosten zu Lasten der Gildenbank "..addon:buildMoneyString(r,true)
		else
			return "Guildvaultrepaircost "..addon:buildMoneyString(r,true)
		end
	end,
	['repaircost'] = function(r)
		if(GetLocale() == "deDE") then
			return "Reparaturkosten "..addon:buildMoneyString(r,true)
		else
			return "Repaired for "..addon:buildMoneyString(r,true)
		end
	end,	
}
addon['mhmods'] = addon['mhmods'] or {}
local guildrepair = false -- switch to true to enable guildrepair

local function MERCHANT_SHOW()
	guildrepair = getPref('guildrepair') or false
  if(CanMerchantRepair()) then
    local m = GetMoney()
    local r = GetRepairAllCost()
    local gbr = false
    if(guildrepair) then
      if(CanGuildBankRepair()) then
        gbr = true
      end
    end
    if(r > 0 and (m > r or gbr)) then
      if(gbr) then
        RepairAllItems(1)
        addon:Print(message['repaircostgb'](r))
      else
        RepairAllItems()
        addon:Print(message['repaircost'](r))
      end
    end
  end
end

addon['mhmods'][#addon['mhmods'] + 1] = {
	['name'] = modName,
	['message'] = message[GetLocale()] or message["enUS"],
	['events'] = { "MERCHANT_SHOW" },
	['onevent'] = MERCHANT_SHOW,
	['init'] = function() 
	options = addon['MH_GetOptions']()
		local grp = addon:AddConfigMenu({['name'] = modName, ['order'] = 20},options)
		addon:AddConfigEntry("zz_MiscHelper","toggle","guildrepair",GetLocale() == "deDE" and "Benutze Gildenbank" or "Use Guildbank funds",nil,1,nil,nil,nil,nil,grp)
	end
}