local name, addon = ...
local modName = "sellgrey"
local GetLocale = GetLocale
local defaults = {
		['sellCards'] = true,
}
local options

local message = {
  ["enUS"] = "Sell grey items",
  ["deDE"] = "Verkaufe graue Gegenst\195\164nde",
	['solditem'] = function(link,price)
		if(GetLocale() == "deDE") then
			return link.." verkauft f\195\188r "..addon:buildMoneyString(price,true)
		else
			return link.." sold for "..addon:buildMoneyString(price,true)
		end
	end,
	['earnedmoney'] = function(earnedMoney)
		if(GetLocale() == "deDE") then
			return addon:buildMoneyString(earnedMoney,true).." verdient."
		else
			return "Earned "..addon:buildMoneyString(earnedMoney,true).."."
		end
	end,
}
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
local GetContainerNumSlots = GetContainerNumSlots
local GetContainerItemLink = GetContainerItemLink
local GetContainerItemInfo = GetContainerItemInfo

local function getPref2(key)
	local db = addon['MH_GetDB'](modName, defaults)
	return db[key]
end

local function getPref(pref)
	return getPref2(pref[#pref])
end

local function setPref(pref,value)
	local db = addon['MH_GetDB'](modName, defaults)
	db[pref[#pref]] = value
end

local function MERCHANT_SHOW(self,event,dont)
	local info,i = {},{}
	local a = 0
	local numberOfSlots,link,id
	local earnedMoney = 0
	while(a<=NUM_BAG_SLOTS) do
		numberOfSlots = GetContainerNumSlots(a)
		local b = 1
		while(b<=numberOfSlots) do
			link = GetContainerItemLink(a, b)
			if(link) then
				id = addon:getItemId(link)
				if(id) then
					info = addon:itemInfo(id)
					if(info) then
						if(info['itemRarity'] == 0 or (getPref2('sellCards') and info['itemName'] == GetItemInfo(62559))) then
							if(info['itemSellPrice'] and info['itemSellPrice'] > 0) then
								local _, itemCount, _, _, _ = GetContainerItemInfo(a, b)
								if(not dont) then
									addon:Print(message['solditem'](link,info['itemSellPrice']))
								end
								earnedMoney = earnedMoney + info['itemSellPrice'] * itemCount
								UseContainerItem(a, b)
							end
						end
					end
				end
			end
			b = b + 1
		end
		a = a + 1
	end
	if(earnedMoney > 0 and not dont) then
		addon:Print(message['earnedmoney'](earnedMoney))
	end
	if(earnedMoney>0 and not dont) then
		C_Timer.After(0.5,function() MERCHANT_SHOW(self,event,true) end)
	end
end

addon['mhmods'] = addon['mhmods'] or {}

addon['mhmods'][#addon['mhmods'] + 1] = {
	['name'] = modName,
	['message'] = message[GetLocale()] or message["enUS"],
	['events'] = { "MERCHANT_SHOW" },
	['onevent'] = MERCHANT_SHOW,
	['init'] = function()
		options = addon['MH_GetOptions']()
		local grp = addon:AddConfigMenu({['name'] = modName, ['order'] = 20,['menuGet'] = getPref, ['menuSet'] = setPref},options)
		addon:AddConfigEntry("zz_MiscHelper","toggle","sellCards","Sell Fortune Cards",nil,1,nil,nil,nil,nil,grp)
	end
}